(use-modules (ice-9 match)
             (srfi srfi-1)
             (chickadee)
             (chickadee math vector)
             (chickadee render color)
             (chickadee render shapes))

(define lines
  (list-tabulate 48
                 (lambda (n)
                   (list #v((random 640) (random 480))
                         #v((random 640) (random 480))
                         (make-color (random:uniform)
                                     (random:uniform)
                                     (random:uniform)
                                     1.0)
                         (1+  (random 16))))))

(define (draw alpha)
  (for-each (match-lambda
              ((start end color thickness)
               (draw-line start end
                          #:feather 1.5
                          #:color color
                          #:thickness thickness)))
            lines))

(run-game #:draw draw)
